/* macro.c  macro expansion
	11 Feb 2005
	use in som vy1   24 Feb 2005
	for t-code		 30 Dec 2005
 */

#include "compile.h"

// return pointer to n-th ele of e
PRIVATE int pick(int e, int n){
	if( e == NIL) return NIL;
	if( n < 1 ) return NIL;
	if( n == 1 ) return car(e);
	return pick(cdr(e),n-1);
}

// map atom a with n-arg in e2, e2 is the actual arg list
// substitute "get.n" with n-th ele of e2
PRIVATE int mapAtom(int a, int e2){
	int e, e3, c, n;
	c = car(a);
	if( c != LNAME ) return a;
	n = cdr(a);
	e3 = pick(e2,n);	// n-arg of caller
	return e3;
}

// e1 is the body of macro def, e2 is the actual arg list
PRIVATE int subst(int e1, int e2){
	if( e1 == NIL)
		return NIL;
	if( isatom(e1) )
		return mapAtom(e1,e2);
	if( isatom(car(e1)) )
		return cons(mapAtom(car(e1),e2), subst(cdr(e1),e2));
	else
		return cons(subst(car(e1),e2), subst(cdr(e1),e2));
}

// macro expansion
int domacro(int idx, int el){
	int body, e, v, b;
	int i, op, n, arity, first;

	if( getType(idx) == tyMAC ){	// simple macro
//		body = getPref(idx);		som-v16 7 nov 2005
		body = getRef(idx);
		e = subst(body,el);
		v = genex3(e);
	}else{							// full macro
		// extend current f locals
		n = getLv(idx);
		for(i=vmax; i<=vmax+n; i++){
			vrec[i].pair = i;
			vrec[i].free = 1;
		}
		first = vmax;
		vmax += n;
		// pass param
		arity = getArg(idx);
		for(i=1; i<=arity; i++){
			v = genex3(car(el));
			outa3(tMov,first+i,v,0);
			freev(v);
			el = cdr(el);
		}
		// rename body
		i = getRef(idx);
		decode(i,&op,&n);
		while(op != tEnd){
			rename3(op,n,first,&b);
			if(op == tJmp)
				b = n - i + CP;
			outa(op,b);
			v = b & 255;	// arg a1
			i++;
			decode(i,&op,&n);
		}
	}
	return v;
}

